package com.cirmuller.maidaddition.network;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.cirmuller.maidaddition.MaidPluginIn;
import com.cirmuller.maidaddition.entity.memory.CanChunkLoadedMemory;
import com.cirmuller.maidaddition.entity.memory.MemoryRegistry;
import com.github.tartaricacid.touhoulittlemaid.entity.passive.EntityMaid;
import java.util.function.Supplier;
import net.minecraft.network.FriendlyByteBuf;
import net.minecraft.server.level.ServerPlayer;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.ai.memory.MemoryModuleType;
import net.minecraftforge.network.NetworkEvent;
import org.apache.logging.log4j.LogManager;

public class MaidChunkLoadingMessage {
  private int maidId;
  
  private boolean usable;
  
  public MaidChunkLoadingMessage(int maidId, boolean usable) {
    this.maidId = maidId;
    this.usable = usable;
  }
  
  public static void encode(com.cirmuller.maidaddition.network.MaidChunkLoadingMessage message, FriendlyByteBuf buffer) {
    buffer.writeInt(message.maidId);
    buffer.writeBoolean(message.usable);
  }
  
  public static com.cirmuller.maidaddition.network.MaidChunkLoadingMessage decode(FriendlyByteBuf buffer) {
    return new com.cirmuller.maidaddition.network.MaidChunkLoadingMessage(buffer.readInt(), buffer.readBoolean());
  }
  
  public static void handler(com.cirmuller.maidaddition.network.MaidChunkLoadingMessage message, Supplier<NetworkEvent.Context> contextSupplier) {
    NetworkEvent.Context context = contextSupplier.get();
    if (context.getDirection().getReceptionSide().isServer())
      context.enqueueWork(() -> {
            ServerPlayer player = context.getSender();
            if (player == null)
              return; 
            Entity entity = player.m_9236_().m_6815_(message.maidId);
            if (entity instanceof EntityMaid) {
              EntityMaid entityMaid = (EntityMaid)entity;
              if (entityMaid.m_21830_((LivingEntity)player)) {
                LogManager.getLogger("maidaddition").info("Now the canChunkLoadMemory is " + message.usable);
                entityMaid.m_6274_().m_21879_((MemoryModuleType)MemoryRegistry.CAN_CHUNK_LOADED.get(), Boolean.valueOf(message.usable));
                entityMaid.setAndSyncData(MaidPluginIn.canChunkLoadedData, new CanChunkLoadedMemory(Boolean.valueOf(message.usable)));
              } 
            } 
          }); 
    context.setPacketHandled(true);
  }
}
